package statemachinetest.service.builder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IDiagram;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.INamedElement;
import com.change_vision.jude.api.inf.model.IOperation;
import com.change_vision.jude.api.inf.model.IPackage;
import com.change_vision.jude.api.inf.model.IStateMachineDiagram;

public class StateMachineManager {

	/*
	 * key :dgm [IStateMachineDiagram] value:dgm's parent [INamedElement]
	 */
	private Map<IDiagram, INamedElement> stateMachineDgmParentMap = new HashMap<IDiagram, INamedElement>();

	public StateMachineManager(){
		// set up information
		this.stateMachineDgmParentMap.clear();
	}
	
	public Map<IDiagram, INamedElement> getStateMachineDgmParentMap() {
		return stateMachineDgmParentMap;
	}

	public void setStateMachineDgmParentMap(
			Map<IDiagram, INamedElement> stateMachineDgmParentMap) {
		this.stateMachineDgmParentMap = stateMachineDgmParentMap;
	}

	public void cleanStateMachineDgmParentMap() {
		this.stateMachineDgmParentMap.clear();
	}

	
	protected IStateMachineDiagram[] getAllStateMachineDiagrams(IModel iModel) {

		List<IDiagram> diagrams = getAllStateMachineDiagrams(iModel,
				new ArrayList<IDiagram>());
		IStateMachineDiagram[] diagramArrays = (IStateMachineDiagram[]) diagrams
				.toArray(new IStateMachineDiagram[diagrams.size()]);

		return diagramArrays;

	}

	private List<IDiagram> getAllStateMachineDiagrams(
			INamedElement iNamedElement, List<IDiagram> diagrams) {
		IDiagram[] dgms = iNamedElement.getDiagrams();
		for (int i = 0; i < dgms.length; i++) {
			if (dgms[i] instanceof IStateMachineDiagram) {
				diagrams.add(dgms[i]);
				stateMachineDgmParentMap.put(dgms[i], iNamedElement);
			}
		}
		if (iNamedElement instanceof IPackage) {
			INamedElement[] children = ((IPackage) iNamedElement)
					.getOwnedElements();
			for (int i = 0; i < children.length; i++) {
				diagrams = getAllStateMachineDiagrams(
						(INamedElement) children[i], diagrams);
			}
		}
		if (iNamedElement instanceof IClass) {
			IOperation[] children = ((IClass) iNamedElement).getOperations();
			for (int i = 0; i < children.length; i++) {
				diagrams = getAllStateMachineDiagrams(
						(INamedElement) children[i], diagrams);
			}
		}
		return diagrams;
	}

}
